glibmm 2.56.0

Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
Glib::MatchInfo Class Reference

MatchInfo - MatchInfo is used to retrieve information about the regular expression match which created it. More...

`#include <glibmm/regex.h>`

## Public Member Functions
| MatchInfo ()
| Default constructor. More...
| MatchInfo (GMatchInfo* castitem, bool take_the_ownership=true)
| C object constructor. More...
| MatchInfo (const MatchInfo& other)=delete
MatchInfo& | operator= (const MatchInfo& other)=delete
| MatchInfo (MatchInfo&& other) noexcept
MatchInfo& | operator= (MatchInfo&& other) noexcept
virtual | ~MatchInfo ()
| Destructor. More...
GMatchInfo* | gobj ()
| Provides access to the underlying C object. More...
const GMatchInfo* | gobj () const
| Provides access to the underlying C object. More...
Glib::RefPtr< Regex > | get_regex ()
| Returns Regex object used in match_info. More...
Glib::RefPtr< const Regex > | get_regex () const
| Returns Regex object used in match_info. More...
Glib::ustring | get_string () const
| Returns the string searched with match_info. More...
bool | matches () const
| Returns whether the previous match operation succeeded. More...
bool | next ()
| Scans for the next match using the same parameters of the previous call to g_regex_match_full() or g_regex_match() that returned match_info. More...
int | get_match_count () const
| Retrieves the number of matched substrings (including substring 0, that is the whole matched text), so 1 is returned if the pattern has no substrings in it and 0 is returned if the match failed. More...
bool | is_partial_match () const
| Usually if the string passed to g_regex_match*() matches as far as it goes, but is too short to match the entire pattern, `false` is returned. More...
Glib::ustring | expand_references (const Glib::ustring& string_to_expand)
| Returns a new string containing the text in string_to_expand with references and escape sequences expanded. More...
Glib::ustring | fetch (int match_num)
| Retrieves the text matching the match_num'th capturing parentheses. More...
bool | fetch_pos (int match_num, int& start_pos, int& end_pos)
| Retrieves the position in bytes of the match_num'th capturing parentheses. More...
Glib::ustring | fetch_named (const Glib::ustring& name)
| Retrieves the text matching the capturing parentheses named name. More...
bool | fetch_named_pos (const Glib::ustring& name, int& start_pos, int& end_pos)
| Retrieves the position in bytes of the capturing parentheses named name. More...
Glib::StringArrayHandle | fetch_all ()
| Bundles up pointers to each of the matching substrings from a match and stores them in an array of gchar pointers. More...

## Protected Member Functions
void | set_gobject (GMatchInfo* castitem, bool take_ownership=true)

## Protected Attributes
GMatchInfo* | gobject_
bool | take_ownership

## Detailed Description

MatchInfo - MatchInfo is used to retrieve information about the regular expression match which created it.

Since glibmm 2.28:

## Constructor & Destructor Documentation

## ◆ MatchInfo() [1/4]

Glib::MatchInfo::MatchInfo | ( |  | ) |

Default constructor.

## ◆ MatchInfo() [2/4]

Glib::MatchInfo::MatchInfo | ( | GMatchInfo * | castitem,
|  | bool | take_the_ownership = `true`
| ) |  |
| explicit

C object constructor.

Parameters

  castitem | The C object.
  take_the_ownership | Whether to destroy the C object with the wrapper or not.

## ◆ MatchInfo() [3/4]

Glib::MatchInfo::MatchInfo | ( | const MatchInfo& | other | ) |
| delete

## ◆ MatchInfo() [4/4]

Glib::MatchInfo::MatchInfo | ( | MatchInfo&& | other | ) |
| noexcept

## ◆ ~MatchInfo()

virtual Glib::MatchInfo::~MatchInfo | ( |  | ) |
| virtual

Destructor.

## Member Function Documentation

## ◆ expand_references()

Glib::ustring Glib::MatchInfo::expand_references | ( | const Glib::ustring& | string_to_expand | ) |

Returns a new string containing the text in string_to_expand with references and escape sequences expanded.

References refer to the last match done with string against regex and have the same syntax used by g_regex_replace().

The string_to_expand must be UTF-8 encoded even if REGEX_RAW was passed to g_regex_new().

The backreferences are extracted from the string passed to the match function, so you cannot call this function after freeing the string.

match_info may be `nullptr` in which case string_to_expand must not contain references. For instance "foo\\n" does not refer to an actual pattern and '\n' merely will be replaced with \n character, while to expand "\\0" (whole match) one needs the result of a match. Use g_regex_check_replacement() to find out whether string_to_expand contains references.

Since glibmm 2.14:

Parameters

  string_to_expand | The string to expand.

Returns
  The expanded string, or `nullptr` if an error occurred.

Exceptions

  Glib::RegexError |

## ◆ fetch()

Glib::ustring Glib::MatchInfo::fetch | ( | int | match_num | ) |

Retrieves the text matching the match_num'th capturing parentheses.

0 is the full text of the match, 1 is the first paren set, 2 the second, and so on.

If match_num is a valid sub pattern but it didn't match anything (e.g. sub pattern 1, matching "b" against "(a)?b") then an empty string is returned.

If the match was obtained using the DFA algorithm, that is using g_regex_match_all() or g_regex_match_all_full(), the retrieved string is not that of a set of parentheses but that of a matched substring. Substrings are matched in reverse order of length, so 0 is the longest match.

The string is fetched from the string passed to the match function, so you cannot call this function after freeing the string.

Since glibmm 2.14:

Parameters

  match_num | Number of the sub expression.

Returns
  The matched substring, or `nullptr` if an error occurred. You have to free the string yourself.

## ◆ fetch_all()

Glib::StringArrayHandle Glib::MatchInfo::fetch_all | ( |  | ) |

Bundles up pointers to each of the matching substrings from a match and stores them in an array of gchar pointers.

The first element in the returned array is the match number 0, i.e. the entire matched text.

If a sub pattern didn't match anything (e.g. sub pattern 1, matching "b" against "(a)?b") then an empty string is inserted.

If the last match was obtained using the DFA algorithm, that is using g_regex_match_all() or g_regex_match_all_full(), the retrieved strings are not that matched by sets of parentheses but that of the matched substring. Substrings are matched in reverse order of length, so the first one is the longest match.

The strings are fetched from the string passed to the match function, so you cannot call this function after freeing the string.

Since glibmm 2.14:

Returns
  A `nullptr`-terminated array of gchar * pointers. If the previous match failed `nullptr` is returned.

## ◆ fetch_named()

Glib::ustring Glib::MatchInfo::fetch_named | ( | const Glib::ustring& | name | ) |

Retrieves the text matching the capturing parentheses named name.

If name is a valid sub pattern name but it didn't match anything (e.g. sub pattern "X", matching "b" against "(?P<X>a)?b") then an empty string is returned.

The string is fetched from the string passed to the match function, so you cannot call this function after freeing the string.

Since glibmm 2.14:

Parameters

  name | Name of the subexpression.

Returns
  The matched substring, or `nullptr` if an error occurred. You have to free the string yourself.

## ◆ fetch_named_pos()

bool Glib::MatchInfo::fetch_named_pos | ( | const Glib::ustring& | name,
|  | int & | start_pos,
|  | int & | end_pos
| ) |  |

Retrieves the position in bytes of the capturing parentheses named name.

If name is a valid sub pattern name but it didn't match anything (e.g. sub pattern "X", matching "b" against "(?P<X>a)?b") then start_pos and end_pos are set to -1 and `true` is returned.

Since glibmm 2.14:

Parameters

  name | Name of the subexpression.
  start_pos | Pointer to location where to store the start position, or `nullptr`.
  end_pos | Pointer to location where to store the end position, or `nullptr`.

Returns
  `true` if the position was fetched, `false` otherwise. If the position cannot be fetched, start_pos and end_pos are left unchanged.

## ◆ fetch_pos()

bool Glib::MatchInfo::fetch_pos | ( | int | match_num,
|  | int & | start_pos,
|  | int & | end_pos
| ) |  |

Retrieves the position in bytes of the match_num'th capturing parentheses.

0 is the full text of the match, 1 is the first paren set, 2 the second, and so on.

If match_num is a valid sub pattern but it didn't match anything (e.g. sub pattern 1, matching "b" against "(a)?b") then start_pos and end_pos are set to -1 and `true` is returned.

If the match was obtained using the DFA algorithm, that is using g_regex_match_all() or g_regex_match_all_full(), the retrieved position is not that of a set of parentheses but that of a matched substring. Substrings are matched in reverse order of length, so 0 is the longest match.

Since glibmm 2.14:

Parameters

  match_num | Number of the sub expression.
  start_pos | Pointer to location where to store the start position, or `nullptr`.
  end_pos | Pointer to location where to store the end position, or `nullptr`.

Returns
  `true` if the position was fetched, `false` otherwise. If the position cannot be fetched, start_pos and end_pos are left unchanged.

## ◆ get_match_count()

int Glib::MatchInfo::get_match_count | ( |  | ) | const

Retrieves the number of matched substrings (including substring 0, that is the whole matched text), so 1 is returned if the pattern has no substrings in it and 0 is returned if the match failed.

If the last match was obtained using the DFA algorithm, that is using g_regex_match_all() or g_regex_match_all_full(), the retrieved count is not that of the number of capturing parentheses but that of the number of matched substrings.

Since glibmm 2.14:

Returns
  Number of matched substrings, or -1 if an error occurred.

## ◆ get_regex() [1/2]

Glib::RefPtr<Regex> Glib::MatchInfo::get_regex | ( |  | ) |

Returns Regex object used in match_info.

It belongs to Glib and must not be freed. Use g_regex_ref() if you need to keep it after you free match_info object.

Since glibmm 2.14:

Returns
  Regex object used in match_info.

## ◆ get_regex() [2/2]

Glib::RefPtr<const Regex> Glib::MatchInfo::get_regex | ( |  | ) | const

Returns Regex object used in match_info.

It belongs to Glib and must not be freed. Use g_regex_ref() if you need to keep it after you free match_info object.

Since glibmm 2.14:

Returns
  Regex object used in match_info.

## ◆ get_string()

Glib::ustring Glib::MatchInfo::get_string | ( |  | ) | const

Returns the string searched with match_info.

This is the string passed to g_regex_match() or g_regex_replace() so you may not free it before calling this function.

Since glibmm 2.14:

Returns
  The string searched with match_info.

## ◆ gobj() [1/2]

GMatchInfo* Glib::MatchInfo::gobj | ( |  | ) |
| inline

Provides access to the underlying C object.

## ◆ gobj() [2/2]

const GMatchInfo* Glib::MatchInfo::gobj | ( |  | ) | const
| inline

Provides access to the underlying C object.

## ◆ is_partial_match()

bool Glib::MatchInfo::is_partial_match | ( |  | ) | const

Usually if the string passed to g_regex_match*() matches as far as it goes, but is too short to match the entire pattern, `false` is returned.

There are circumstances where it might be helpful to distinguish this case from other cases in which there is no match.

Consider, for example, an application where a human is required to type in data for a field with specific formatting requirements. An example might be a date in the form ddmmmyy, defined by the pattern "^\\d?\\d(jan|feb|mar|apr|may|jun|jul|aug|sep|oct|nov|dec)\\d\\d$". If the application sees the user’s keystrokes one by one, and can check that what has been typed so far is potentially valid, it is able to raise an error as soon as a mistake is made.

GRegex supports the concept of partial matching by means of the REGEX_MATCH_PARTIAL_SOFT and REGEX_MATCH_PARTIAL_HARD flags. When they are used, the return code for g_regex_match() or g_regex_match_full() is, as usual, `true` for a complete match, `false` otherwise. But, when these functions return `false`, you can check if the match was partial calling g_match_info_is_partial_match().

The difference between REGEX_MATCH_PARTIAL_SOFT and REGEX_MATCH_PARTIAL_HARD is that when a partial match is encountered with REGEX_MATCH_PARTIAL_SOFT, matching continues to search for a possible complete match, while with REGEX_MATCH_PARTIAL_HARD matching stops at the partial match. When both REGEX_MATCH_PARTIAL_SOFT and REGEX_MATCH_PARTIAL_HARD are set, the latter takes precedence.

There were formerly some restrictions on the pattern for partial matching. The restrictions no longer apply.

See pcrepartial(3) for more information on partial matching.

Since glibmm 2.14:

Returns
  `true` if the match was partial, `false` otherwise.

## ◆ matches()

bool Glib::MatchInfo::matches | ( |  | ) | const

Returns whether the previous match operation succeeded.

Since glibmm 2.14:

Returns
  `true` if the previous match operation succeeded, `false` otherwise.

## ◆ next()

bool Glib::MatchInfo::next | ( |  | ) |

Scans for the next match using the same parameters of the previous call to g_regex_match_full() or g_regex_match() that returned match_info.

The match is done on the string passed to the match function, so you cannot free it before calling this function.

Since glibmm 2.14:

Returns
  `true` is the string matched, `false` otherwise.

Exceptions

  Glib::RegexError |

## ◆ operator=() [1/2]

MatchInfo& Glib::MatchInfo::operator= | ( | const MatchInfo& | other | ) |
| delete

## ◆ operator=() [2/2]

MatchInfo& Glib::MatchInfo::operator= | ( | MatchInfo&& | other | ) |
| noexcept

## ◆ set_gobject()

void Glib::MatchInfo::set_gobject | ( | GMatchInfo * | castitem,
|  | bool | take_ownership = `true`
| ) |  |
| protected

## Member Data Documentation

## ◆ gobject_

GMatchInfo* Glib::MatchInfo::gobject_
| protected

## ◆ take_ownership

bool Glib::MatchInfo::take_ownership
| protected